﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace GpsModule {
	public class RmcStrategy {

		public delegate void updateErrorEventHandler(Exception error);
		public event updateErrorEventHandler updateErrorEvent;

		RmcData _data;
		public RmcData Data {
			get { return _data; }
		}

		public RmcStrategy() {
			_data = new RmcData();
		}

		public void parseSentance(string sentence) {
			try {
				_data.setSentance(sentence);
				//1) Time (UTC)
				sentence = sentence.Substring(sentence.IndexOf(",") + 1, sentence.Length - sentence.IndexOf(",") - 1);
				string s = sentence.Substring(0, sentence.IndexOf(","));
				int hour;
				int.TryParse(s.Substring(0, 2), out hour);
				int minute;
				int.TryParse(s.Substring(2, 2), out minute);
				int second;
				int.TryParse(s.Substring(4, 2), out second);
				//2) Status, V = Navigation receiver warning
				sentence = sentence.Substring(sentence.IndexOf(",") + 1, sentence.Length - sentence.IndexOf(",") - 1);
				_data.setStatus(sentence.Substring(0, sentence.IndexOf(","))[0]);
				//3) Latitude
				sentence = sentence.Substring(sentence.IndexOf(",") + 1, sentence.Length - sentence.IndexOf(",") - 1);
				_data.setLatitude(sentence.Substring(0, sentence.IndexOf(",")));
				//4) N or S
				sentence = sentence.Substring(sentence.IndexOf(",") + 1, sentence.Length - sentence.IndexOf(",") - 1);
				_data.setNorthOrSouth(sentence.Substring(0, sentence.IndexOf(","))[0]);
				//5) Longitude
				sentence = sentence.Substring(sentence.IndexOf(",") + 1, sentence.Length - sentence.IndexOf(",") - 1);
				_data.setLongitude(sentence.Substring(0, sentence.IndexOf(",")));
				//6) E or W
				sentence = sentence.Substring(sentence.IndexOf(",") + 1, sentence.Length - sentence.IndexOf(",") - 1);
				_data.setEastOrWest(sentence.Substring(0, sentence.IndexOf(","))[0]);
				//7) Speed over ground, knots
				sentence = sentence.Substring(sentence.IndexOf(",") + 1, sentence.Length - sentence.IndexOf(",") - 1);
				_data.setSpeedOverGround(double.Parse(sentence.Substring(0, sentence.IndexOf(","))));
				//8) Track made good, degrees true
				sentence = sentence.Substring(sentence.IndexOf(",") + 1, sentence.Length - sentence.IndexOf(",") - 1);
				_data.setTrackMadeGood(double.Parse(sentence.Substring(0, sentence.IndexOf(","))));
				//9) Date, ddmmyy
				sentence = sentence.Substring(sentence.IndexOf(",") + 1, sentence.Length - sentence.IndexOf(",") - 1);
				s = sentence.Substring(0, sentence.IndexOf(","));
				int day;
				int.TryParse(s.Substring(0, 2), out day);
				int month;
				int.TryParse(s.Substring(2, 2), out month);
				int year;
				int.TryParse(s.Substring(4, 2), out year);
				year += 2000;
				//10) Magnetic Variation, degrees
				sentence = sentence.Substring(sentence.IndexOf(",") + 1, sentence.Length - sentence.IndexOf(",") - 1);
				//_data.setMagneticVariation(double.Parse(sentence.Substring(0, sentence.IndexOf(","))));
				//11) E or W
				sentence = sentence.Substring(sentence.IndexOf(",") + 1, sentence.Length - sentence.IndexOf(",") - 1);
				_data.setEastOrWestM(sentence.Substring(0, sentence.IndexOf("*"))[0]);
				//12) Checksum
				sentence = sentence.Substring(sentence.IndexOf("*") + 1, sentence.Length - sentence.IndexOf("*") - 1);
				//_checksum = sentence.Substring(0, sentence.Length);
				_data.setTime(new DateTime(year, month, day, hour, minute, second, DateTimeKind.Utc));
			} catch (Exception e) {
				if (updateErrorEvent != null)
					updateErrorEvent.Invoke(e);
			}
		}
	}
}
