﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace PlatformController {
	public static class PidControl {

		static double _Kp = 1, _Ki = 1, _Kd = 1;

		public static double Kp {
			get { return PidControl._Kp; }
		}

		public static double Ki {
			get { return PidControl._Ki; }
		}

		public static double Kd {
			get { return PidControl._Kd; }
		}
		static double _pComponent = 0, _iComponent = 0, _dComponent = 0;

		public static double PComponent {
			get { return PidControl._pComponent; }
		}

		public static double IComponent {
			get { return PidControl._iComponent; }
		}

		public static double DComponent {
			get { return PidControl._dComponent; }
		}

		static double manipulatedVariable = 0;

		public static void setPidCoefficients(double Kp, double Ki, double Kd) {
			_Kp = Kp;
			_Ki = Ki;
			_Kd = Kd;
		}

		public static double getMvFromInput(double setpoint, List<int> processData, double timespan) {
			_pComponent = 0;
			_iComponent = 0;
			_dComponent = 0;
			//calculate porportional gain
			_pComponent = setpoint - ((double)processData.Sum() / timespan);
			//calculate integral gain, area under the curve
			foreach (int d in processData)
				_iComponent += setpoint - ((double)d * ((double)processData.Count / timespan));
			//calculate derivitave gain only if the data set intersects the setpoint
			for (int i = 0; i < processData.Count; ++i ) {
				if ((double)processData[i] * ((double)processData.Count / timespan) > setpoint) {
					_dComponent = (double)(processData[processData.Count - 1] - processData[0]) / timespan;
					_dComponent = -1.0 * _dComponent;
					break;
				}
			}
			manipulatedVariable = _pComponent * _Kp + (_iComponent * _Ki) + (_dComponent * _Kd);
			return manipulatedVariable;
		}

	}
}
