﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using UtmConvert;

namespace RacePlotter {
    public partial class PointEditor : Form {
        public delegate void pointEditEventHandler();
        public event pointEditEventHandler pointEditEvent;

        UtmPoint _pt;

		public PointEditor(UtmPoint pt) {
            InitializeComponent();
            _pt = pt;
            utmPointPropertyGrid.SelectedObject = _pt;
			pointPropertyGrid.SelectedObject = _pt.Point;
            this.Text = "Edit Point: " 
                + Math.Round(_pt.Point.X, 2).ToString() + ", "
                + Math.Round(_pt.Point.Y, 2).ToString();
        }

        private void editButton_Click(object sender, EventArgs e) {
			if (pointEditEvent != null)
				pointEditEvent.Invoke();
        }

        private void doneBlutton_Click(object sender, EventArgs e) {
            this.Close();
        }

        public UtmPoint getEditedPoint() {
            return _pt;
        }

    }
}
