﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using UtmConvert;
using System.Drawing;
using System.ComponentModel;

namespace RacePlotter {
	class RacePlotterData {

		protected string _racePath = ".\\race\\default\\";
		
		protected List<UtmPoint> _fiducials;
		//Summary:
		//List of UTM fiducials 
		[CategoryAttribute("Race Plotter Settings")
		, DescriptionAttribute("List of UTM fiducials")]
		public List<UtmPoint> Fiducials {
			get { return _fiducials; }
		}

		protected List<UtmPoint> _waypoints;
		//Summary:
		//List of UTM waypoints 
		[CategoryAttribute("Race Plotter Settings")
		, DescriptionAttribute("List of UTM waypoints")]
		public List<UtmPoint> Waypoints {
			get { return _waypoints; }
			set { _waypoints = value; }
		}

		protected Bitmap _raceMap;

		public Bitmap RaceMap {
			get { return _raceMap; }
		}

		protected System.Drawing.Point _click1, _click2;

		public System.Drawing.Point Click1 {
			get { return _click1; }
			set { _click1 = value; }
		}

		public System.Drawing.Point Click2 {
			get { return _click2; }
			set { _click2 = value; }
		}

		protected UtmPoint _gpsPosition, _statePosition;
		public UtmPoint GpsPosition {
			get { return _gpsPosition; }
			set { _gpsPosition = value; }
		}

		public UtmPoint StatePosition {
			get { return _statePosition; }
			set { _statePosition = value; }
		}

		protected UtmPoint _fiducial1, _fiducial2;
		public UtmPoint Fiducial1 {
			get { return _fiducial1; }
			set { _fiducial1 = value; }
		}

		public UtmPoint Fiducial2 {
			get { return _fiducial2; }
			set { _fiducial2 = value; }
		}

		protected double _scaleDeltaX;
		public double ScaleDeltaX {
			get { return _scaleDeltaX; }
		}

		protected double _scaleDeltaY;
		public double ScaleDeltaY {
			get { return _scaleDeltaY; }
		}

		protected double _scaleX;
		public double ScaleX {
			get { return _scaleX; }
		}

		protected double _scaleY;
		public double ScaleY {
			get { return _scaleY; }
		}
		 

	}
}
